#!/usr/bin/php
<?

/*Generates a conversion table from 'real' hue values to the weird hues
the LivingColors light uses.*/

//These are the hue-values that, when entered into the LivingColors-lamp,
//generate the colors red, yellow, green, cyan, blue, magenta, (red+256)
$observed=array(2,73,102,150,186,205,258);
echo "const PROGMEM unsigned char hue_convtab={";
for ($i=0; $i<256; $i++) {
    if (($i&7)==0) echo "\n    ";
    $p=$i/256*6;
    $ob_pos=intval($p);
    $int_pos=$p-$ob_pos;
    $val=$observed[$ob_pos]*(1-$int_pos)+$observed[$ob_pos+1]*$int_pos;
    echo intval($val+.5).", ";
}
echo "};\n";

?>